﻿<?php
/*
 * 			tpay.com dla Virtuemart 2 (Joomla 1.5-2.5)
 *
 * 			Wszelkie prawa zastrzeżone - Dodatkijoomla.pl
 *
 */
if (!defined('_VALID_MOS') && !defined('_JEXEC')) {
    die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');
}

// jeżeli klasa vmPSPlugin nie istnieje, dołącz
if (!class_exists('vmPSPlugin')) {
    require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');
}

class plgVmPaymentTransferuj extends vmPSPlugin
{

    public static $_this = false;

    // konstruktor
    function __construct(& $subject, $config)
    {
        // konstruktor kl. nadrzędnej
        parent::__construct($subject, $config);

        $this->_loggable = true;

        // to poniżej apisuje wartości z xml'a do kol. payment_params tabeli #__virtuemart_paymentmethods
        $this->tableFields = array_keys($this->getTableSQLFields());
        $varsToPush = array(
            'transferuj_id' => array('', 'string'),
            'transferuj_kod_potwierdzajacy' => array('', 'string'),
            'transferuj_online' => array(0, 'int'),
            'transferuj_formularz' => array(1, 'int'),
            'transferuj_wyn_url' => array('', 'string'),
            'status_pending' => array('', 'string'),
            'status_success' => array('', 'string'),
            'status_canceled' => array('', 'string'),
            'cost_per_transaction' => array(0, 'double'),
            'cost_percent_total' => array(0, 'double'),
            'tax_id' => array(0, 'int'),
            'autoredirect' => array(1, 'int'),
            'powiadomienia' => array(1, 'int'),
            'payment_logos' => array('logo_tpay.png', 'char'),
        );

        $this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
    }

    function getTableSQLFields()
    {
        $SQLfields = array(
            'id' => ' int(11) UNSIGNED NOT NULL AUTO_INCREMENT ',
            'virtuemart_order_id' => ' int(11) UNSIGNED DEFAULT NULL',
            'order_number' => ' char(32) DEFAULT NULL',
            'virtuemart_paymentmethod_id' => ' mediumint(1) UNSIGNED DEFAULT NULL',
            'payment_name' => 'char(255) NOT NULL DEFAULT \'\' ',
            'tax_id' => 'int(11) DEFAULT NULL',
            'transferuj_crc' => 'varchar(32) ',
            'kwota_zamowienia' => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\' '
        );

        return $SQLfields;
    }

    // potwierdzenie zamówienia funkcja 

    function plgVmPotwierdzenieTransferuj($cart, $order, $auto_redirect = false, $form_method = "GET")
    {
        if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
            return null; // Inna metoda została wybrana, nie rób nic.
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }

        if (!class_exists('VirtueMartModelOrders')) {
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
        }

        // konwersja do PLN
        $this->getPaymentCurrency($method);
        $paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
        $kwota_zamowienia = number_format($paymentCurrency->convertCurrencyTo(114, $order['details']['BT']->order_total,
            false), 2, ".", "");

        // zmienne
        $zamowienie = $order['details']['BT'];
        $session_id = md5($zamowienie->order_number . '|' . time());

//        $q = 'SELECT country_3_code FROM #__virtuemart_countries WHERE virtuemart_country_id=' . addslashes($zamowienie->virtuemart_country_id) . ' ';        // kraj 3 znakowo
//        $db = JFactory::getDBO();
//        $db->setQuery($q);
//        $country = $db->loadResult();
        $md5Params = array(
            $method->transferuj_id,
            $kwota_zamowienia,
            $session_id,
            $method->transferuj_kod_potwierdzajacy,
        );


        $md5sum = md5(implode('&', $md5Params));

        $this->_virtuemart_paymentmethod_id = $zamowienie->virtuemart_paymentmethod_id;
        $dbWartosci['order_number'] = $zamowienie->order_number;
        $dbWartosci['payment_name'] = $this->renderPluginName($method, $order);
        $dbWartosci['virtuemart_paymentmethod_id'] = $this->_virtuemart_paymentmethod_id;
        $dbWartosci['tax_id'] = $method->tax_id;

        //dodatkowe koszty
        $dbWartosci['cost_per_transaction'] = $method->cost_per_transaction;
        $dbWartosci['cost_percent_total'] = $method->cost_percent_total;
        // wartości Transferuj.pl
        $dbWartosci['transferuj_crc'] = $session_id;
        $dbWartosci['kwota_zamowienia'] = $kwota_zamowienia;

        // zapisz do bazy
        $this->storePSPluginInternalData($dbWartosci);
        $resultUrl = JUri::base() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&pm='. $zamowienie->virtuemart_paymentmethod_id . '&status=confirm';
        // zawartośc HTML na podstronie potwierdzenia zamówienia 
        //Numer zamówienia: '.$order['details']['BT']->order_number.'

        $html = '
		<div style="text-align: center; width: 100%; ">
		<form action="https://secure.tpay.com" method="' . $form_method . '" class="form" name="platnosc_transferuj" id="platnosc_transferuj">
			<input type="hidden" name="id" value="' . $method->transferuj_id . '" />
			<input type="hidden" name="kwota" value="' . $kwota_zamowienia . '" />
			<input type="hidden" name="opis" value="Zamówienie nr ' . $order['details']['BT']->order_number . '" />
			<input type="hidden" name="crc" value="' . $session_id . '" />
			<input type="hidden" name="md5sum" value="' . $md5sum . '" />
            <input type="hidden" name="online" value="' . $method->transferuj_online . '" />
            <input type="hidden" name="wyn_url" value="' . $resultUrl . '" />
            <input type="hidden" name="pow_url" value="' . str_replace("confirm", "ok", $resultUrl) . '" />
	        <input type="hidden" name="pow_url_blad" value="' . str_replace("confirm", "error", $resultUrl) . '" />
            <input type="hidden" name="email" value="' . $zamowienie->email . '" />
            <input type="hidden" name="imie" value="' . $zamowienie->first_name . '" />
            <input type="hidden" name="nazwisko" value="' . $zamowienie->last_name . '" />
			<input type="hidden" name="adres" value="' . $zamowienie->address_1 . '" />
            <input type="hidden" name="miasto" value="' . $zamowienie->city . '" />
            <input type="hidden" name="kod" value="' . $zamowienie->zip . '" />
            <input type="hidden" name="telefon" value="' . $zamowienie->phone_1 . '" />
            <input type="hidden" id="channel"  name="kanal" value=" ">
			';

        switch ($method->transferuj_formularz) {
            case 1:
                // wyświetlaj formularz z kanałami na stronie tylko na podstronie złożenia zamówienia
                if ($_REQUEST['view'] == 'cart') {
                    $doc = JFactory::getDocument();
                    $html .= '<script type="text/javascript">
					jQuery.getScript("https://secure.transferuj.pl/channels-' . $method->transferuj_id . $method->transferuj_online . '.js", function () {
                    ShowChannelsCombo()
                });  </script>';
                    $html .= "<div id='transferuj_content'> <div id='kanaly_v'></div></div>";
                    //$doc->addScript("https://secure.tpay.com/channels-" . $method->transferuj_id . $method->transferuj_online . ".js");
                    if (version_compare(JVERSION, '1.6.0', 'ge')) {
                        $doc->addScript("plugins/vmpayment/transferuj/js/showchannels.js");
                    } else {
                        $doc->addScript("plugins/vmpayment/js/showchannels.js");
                    }

                    $cssChannels = "     .checked_v {
                box-shadow: 0px 0px 10px 3px #15428F;

            }
            .channel {
                display: inline-block; 
                width: 140px; 
                height:70px; 
                cursor:pointer;
                text-align:center;
            }
					#kanaly div.selected {
						border: 2px solid #1E63A9;
						border-radius: 4px 4px 4px 4px;
						margin: 3px 3px -1px -1px;
					}

					#kanaly div {
						background-position: left top;
						background-repeat: no-repeat;
						border: 1px solid #DADADA;
						cursor: pointer;
						float: left;
						height: 88px;
						margin-right: 4px;
						margin-top: 4px;
						padding: 5px;
						position: relative;
						width: 127px;
						z-index: 4;
					}

					#kanaly div p.label {
						border: 0 none;
						bottom: 0;
						color: #345565;
						cursor: pointer;
						font-size: 0.625em;
						font-weight: bold;
						left: 0;
						margin: 0;
						padding: 0 0 3px;
						position: absolute;
						right: 0;
						text-align: center;
					}
					";
                    $doc->addStyleDeclaration($cssChannels);

                    // skok do 2 kroku
                    // $html .= '<input type="hidden" name="akceptuje_regulamin" value="1" />';
                    $html .= '<div style="text-align:center">
                       
            <label for="akceptuje_regulamin">
                    <input id="akceptuje_regulamin" type="checkbox" checked="checked" value="1" name="akceptuje_regulamin">
                Akceptuję <a target="_blank" href="https://secure.tpay.com/regulamin.pdf"><b>regulamin</b></a> serwisu Tpay</label>
                             <br>
                            <input type="submit" style="color: white;
                                            margin-top:20px;
                                            width: 225px;
                                            background: #2994E7;
                                            padding: 8px 14px 10px;
                                            border: 2px solid #FBA01C;
                                            border-radius: 10px;"
                                            value="Zapłać z Tpay.com"></div>';

                    break;
                }
            case 0:
                // button
                $html .= '<div style="text-align:center">
                              <img src="logo.png"></br>
                            <input type="submit"  style="color: white;
                                            margin-top:20px;
                                            width: 225px;
                                            background: #2994E7;
                                            padding: 8px 14px 10px;
                                            border: 2px solid #FBA01C;
                                            border-radius: 10px;"
                               value="Zapłać z Tpay" /></div>';

                // automatyczne przerzucenie do płatności
                if ($method->autoredirect && $auto_redirect) {
                    $html .= '   <script type="text/javascript">document.getElementById("platnosc_transferuj").submit();</script>';
                }
                break;
            case 2:
                // wyświetlaj formularz z kanałami na stronie tylko na podstronie złożenia zamówienia
                if ($_REQUEST['view'] == 'cart') {

                    $doc = &JFactory::getDocument();

                    $api_url = "https://secure.tpay.com/channels-" . $method->transferuj_id . $method->transferuj_online . ".js";
                    $ch = curl_init();

                    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
                    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                    curl_setopt($ch, CURLOPT_URL, $api_url);
                    $curl_res = (curl_exec($ch));
                    @curl_close($ch);

                    preg_match_all("/\['(.*?)','(.*?)'/s", $curl_res, $res);
                    $html .= '<div style="text-align:center"><p>Wybierz swój kanał płatności:</p><br/>
                                  <select name="kanal">';

                    for ($i = 0; $i < count($res[1]); $i++) {
                        $html .= "<option  value='" . $res[1][$i] . "'>&nbsp;" . $res[2][$i] . "</option>";
                    }
                    $html .= '</select>';

                    // skok do 2 kroku
                    // $html .= '<input type="hidden" name="akceptuje_regulamin" value="1" />';
                    $html .= '<div style="text-align:center">
                       
            <label style="margin-top: 25px;" for="akceptuje_regulamin">
                    <input id="akceptuje_regulamin" type="checkbox" checked="checked" value="1" name="akceptuje_regulamin">
                Akceptuję <a target="_blank" href="https://secure.tpay.com/regulamin.pdf"><b>regulamin</b></a> serwisu Tpay</label>
                             <br>
                            <input type="submit" style="color: white;
                                            margin-top:5px;
                                            width: 225px;
                                            background: #2994E7;
                                            padding: 8px 14px 10px;
                                            border: 2px solid #FBA01C;
                                            border-radius: 10px;"
                                            value="Zapłać z Tpay"></div></div>';

                    break;
                }
        }

        $html .= '</form></div>';

        //echo $html;

        return $html;
    }

    function plgVmConfirmedOrder($cart, $order)
    {
        // jeżeli nie zwraca $html - wyrzuc false
        if (!($html = $this->plgVmPotwierdzenieTransferuj($cart, $order, true, "POST"))) {
            return false;
        }

        //echo $html;
        // nazwa płatnosci - zmiana dla Joomla 2.5 !!!
        if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
            return null;
        }
        $nazwa_platnosci = $this->renderPluginName($method);

        // tutaj w vm 2.0.2 trzeba dodać status na końcu, zeby się nie wywalało
        return $this->processConfirmedOrderPaymentResponse(1, $cart, $order, $html, $nazwa_platnosci,
            $method->status_pending);
    }

    // zdarzenie po otrzymaniu poprawnego lub błędnego url'a z systemu 
    function plgVmOnPaymentResponseReceived(&$html)
    {
        $virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return null;
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }

        if (isset($_GET['status']) && !empty($_GET['status'])) {
            switch ($_GET['status']) {
                case "ok":
                    // pozytywna
                    JFactory::getApplication()->enqueueMessage('Dziękujemy za dokonanie transakcji za pośrednictwem Tpay.');

                    return true;
                    break;

                case "error":
                    // negatywna
                    JError::raiseWarning(100, 'Wystąpił błąd w trakcie składania płatności za pośrednictwem Tpay.');

                    return true;
                    break;

                case "confirm":
                    // potwierdzenie
                    // IP
                    $ip_table = array(
                        '195.149.229.109',
                        '148.251.96.163',
                        '178.32.201.77',
                        '46.248.167.59',
                        '46.29.19.106'
                    );
                    if (in_array($_SERVER['REMOTE_ADDR'], $ip_table) && isset($_POST) && !empty($_POST)) {
                        // dane z requesta Transferuj
                        $payment_data = $_POST;

                        // porównanie z bazą
                        $db = JFactory::getDBO();
                        $q = 'SELECT transferuj.*, ord.order_status, usr.email  FROM ' . addslashes($this->_tablename) . ' as transferuj JOIN `#__virtuemart_orders` as ord using(virtuemart_order_id) JOIN #__virtuemart_order_userinfos  as usr using(virtuemart_order_id)  WHERE transferuj.transferuj_crc="' . addslashes($payment_data['tr_crc']) . '" ';

                        $db->setQuery($q);
                        $payment_db = $db->loadObject();

                        if (!empty($payment_db)) {

                            $md5_request = $payment_data['md5sum'];

                            $md5_vm["id"] = $method->transferuj_id;
                            $md5_vm["tr_id"] = $payment_data["tr_id"];
                            $md5_vm["tr_amount"] = $payment_data["tr_amount"];
                            $md5_vm["tr_crc"] = $payment_data['tr_crc'];
                            $md5_vm["kod"] = $method->transferuj_kod_potwierdzajacy;
                            $md5_db = md5(implode("", $md5_vm));

                            //echo $md5_request."<br>";
                            //echo $md5_db;
                            // porównanie sum kontrolnych
                            if ($md5_request == $md5_db) {
                                echo "TRUE\r\n";

                                // tr_error
                                $error_msg = "";
                                if ($payment_data['tr_error'] == "overpay") {
                                    $error_msg = "<br><b>Dokonano nadpłaty.</b>";
                                } else {
                                    if ($payment_data['tr_error'] == "surcharge") {
                                        $error_msg = "<br><b>Dokonano niedopłaty.</b>";
                                    }
                                }

                                // poprawna
                                if ($payment_data['tr_status'] == "TRUE") {

                                    if ($payment_db->order_status != "C" && $payment_db->order_status != 'X') {
                                        $virtuemart_order_id = $payment_db->virtuemart_order_id;
                                        $message = 'Płatność została potwierdzona.';
                                        if (!empty($error_msg)) {
                                            $message .= $error_msg;
                                        }
                                        if (($status = $this->nowyStatus($virtuemart_order_id, $method->status_success,
                                                $message, $method->powiadomienia)) == false
                                        ) {
                                            $this->logInfo('plgVmOnPaymentResponseReceived Bład podczas zmiany statusu zamówienia na ' . $method->status_success);
                                        } else {
                                            $this->logInfo('plgVmOnPaymentResponseReceived Potwierdzono zmianę statusu zamówienia na ' . $method->status_success);
                                        }
                                    }
                                } else {
                                    if ($payment_data['tr_status'] == "FALSE") {
                                        if ($payment_db->order_status != "C" && $payment_db->order_status != 'X') {
                                            $virtuemart_order_id = $payment_db->virtuemart_order_id;
                                            $message = 'Płatność została oznaczona jako błędna.';
                                            if (!empty($error_msg)) {
                                                $message .= $error_msg;
                                            }

                                            if (($status = $this->nowyStatus($virtuemart_order_id,
                                                    $method->status_canceled, $message,
                                                    $method->powiadomienia)) == false
                                            ) {
                                                $this->logInfo('plgVmOnPaymentResponseReceived Bład podczas zmiany statusu zamówienia na ' . $method->status_canceled);
                                            } else {
                                                $this->logInfo('plgVmOnPaymentResponseReceived Potwierdzono zmianę statusu zamówienia na ' . $method->status_canceled);
                                            }
                                        }
                                    }
                                }

                                exit();
                            } else {
                                $this->logInfo('plgVmOnPaymentResponseReceived Sumy kontrolne nie są identyczne.');
                            }
                        } else {
                            $this->logInfo('plgVmOnPaymentResponseReceived Pusty rekord pobierania informacji nt. zamówienia z bazy danych.');
                        }
                    }
                    break;
            }
        }
    }

    // wyświetl dane płatności dla zamówienia (backend)
    function plgVmOnShowOrderBEPayment($virtuemart_order_id, $virtuemart_payment_id)
    {
        if (!$this->selectedThisByMethodId($virtuemart_payment_id)) {
            return null; // Another method was selected, do nothing
        }

        $db = JFactory::getDBO();
        $q = 'SELECT * FROM `' . $this->_tablename . '` '
            . 'WHERE `virtuemart_order_id` = ' . addslashes($virtuemart_order_id);
        $db->setQuery($q);
        if (!($paymentTable = $db->loadObject())) {
            vmWarn(500, $q . " " . $db->getErrorMsg());

            return '';
        }
        $this->getPaymentCurrency($paymentTable);

        $html = '<table class="adminlist">' . "\n";
        $html .= $this->getHtmlHeaderBE();
        $html .= $this->getHtmlRowBE('STANDARD_PAYMENT_NAME', $paymentTable->payment_name);
        $html .= $this->getHtmlRowBE('STANDARD_PAYMENT_TOTAL_CURRENCY',
            number_format($paymentTable->kwota_zamowienia, 2, ".", "") . ' ' . $paymentTable->waluta_platnosci);
        $html .= '</table>' . "\n";

        return $html;
    }

    // moja funkcja nowego statusu
    function nowyStatus($virtuemart_order_id, $nowy_status, $notatka = "", $wyslij_powiadomienie = 1)
    {
        if (!class_exists('VirtueMartModelOrders')) {
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
        }

        // załadowanie języka dla templatey zmiany statusu zam. z admina!
        $lang = JFactory::getLanguage();
        $lang->load('com_virtuemart', JPATH_ADMINISTRATOR);

        $modelOrder = VmModel::getModel('orders');
        $zamowienie = $modelOrder->getOrder($virtuemart_order_id);
        if (empty($zamowienie)) {
            return false;
        }

        $order['order_status'] = $nowy_status;
        $order['virtuemart_order_id'] = $virtuemart_order_id;
        $order['customer_notified'] = $wyslij_powiadomienie;
        $order['comments'] = $notatka;
        $modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);

        // last modify + lock płatności w BD			
        $db = JFactory::getDBO();
        // sql'e zależne od nowego statusu

        if ($nowy_status == "C" || $nowy_status == "X") {
            $q = 'UPDATE ' . $this->_tablename . ' SET modified_on=NOW(), locked_on=NOW() WHERE virtuemart_order_id=' . addslashes($virtuemart_order_id) . ';   ';
        } else {
            $q = 'UPDATE ' . $this->_tablename . ' SET modified_on=NOW() WHERE virtuemart_order_id=' . addslashes($virtuemart_order_id) . ';   ';
        }
        //echo $q;	
        $db->setQuery($q);
        $wynik = $db->query($q);

        if (empty($wynik)) {
            return false;
        }

        $message = 'Status zamówienia zmienił się.';

        return $message;
    }

    // dodatkowe koszta płatności (opłaty dodatkowe)
//    function getCosts(VirtueMartCart $cart, $method, $cart_prices) {
//        if (preg_match('/%$/', $method->procentowa_kwota_oplaty)) {
//            $procentowa_kwota_oplaty = substr($method->procentowa_kwota_oplaty, 0, -1);
//        } else {
//            $procentowa_kwota_oplaty = $method->procentowa_kwota_oplaty;
//        }
//        return ($method->stala_kwota_oplaty + ($cart_prices['salesPrice'] * $procentowa_kwota_oplaty * 0.01));
//    }
    // sprawdź czy płatność spełnia wymagania

    function plgVmOnStoreInstallPaymentPluginTable($jplugin_id)
    {
        return $this->onStoreInstallPluginTable($jplugin_id);
    }

    /*
     *
     * 	RESZTA METOD
     *
     */

    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart)
    {
        return $this->OnSelectCheck($cart);
    }

    // utwórz opcjonalnie tabelę płatności, zapisz dane z xml'a itp.

    public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn)
    {
        return $this->displayListFE($cart, $selected, $htmlIn);
    }

    // zdarzenie po wyborze płatności (front)

    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name)
    {
        return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }

    // zdarzenie wywoływane podczas listowania płatności

    function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId)
    {
        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return null; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }
        $this->getPaymentCurrency($method);

        $paymentCurrencyId = $method->payment_currency;
    }

    function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array())
    {
        return $this->onCheckAutomaticSelected($cart, $cart_prices);
    }

    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name)
    {
        $this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }

    // sprawdza ile pluginów płatności jest dostepnych, jeśli tylko jeden, użytkownik nie ma wyboru

    function onShowOrderFE($virtuemart_order_id, $virtuemart_method_id, &$method_info)
    {
        if (!($this->selectedThisByMethodId($virtuemart_method_id))) {
            return null;
        }

        // zmiany w wersji 1.1 (1.5 dla p24), ograniczenie generowania się dodatkowego fomrularza, jeśli klient nie opłacił jeszcze zamówienia, tylko do szczegółów produktu
        // dodatkowo w zależności od serwera, tworzenie faktury w PDF głupieje czasami przy obrazkach dla płatności
        if (isset($_REQUEST['view']) && $_REQUEST['view'] == 'orders' && isset($_REQUEST['layout']) && $_REQUEST['layout'] == 'details') {
            // wywołaj cały formularz
            if (!class_exists('VirtueMartModelOrders')) {
                require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
            }
            if (!class_exists('VirtueMartCart')) {
                require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
            }
            if (!class_exists('CurrencyDisplay')) {
                require(JPATH_VM_ADMINISTRATOR . DS . 'helpers' . DS . 'currencydisplay.php');
            }
            $modelOrder = new VirtueMartModelOrders();
            $cart = VirtueMartCart::getCart();
            $order = $modelOrder->getOrder($virtuemart_order_id);

            if (!($html = $this->plgVmPotwierdzenieTransferuj($cart, $order, false,
                    "POST")) || $order['details']['BT']->order_status == 'C' || $order['details']['BT']->order_status == 'U'
            ) {
                $method_info = $this->getOrderMethodNamebyOrderId($virtuemart_order_id);
            } else {
                $method_info = $html;
            }
        } else {
            $method_info = 'Transferuj.pl';
        }
    }

    // zdarzenie wywoływane podczas przeglądania szczegółów zamówienia (front)

    function getOrderMethodNamebyOrderId($virtuemart_order_id)
    {

        $db = JFactory::getDBO();
        $q = 'SELECT * FROM `' . $this->_tablename . '` '
            . 'WHERE `virtuemart_order_id` = ' . addslashes($virtuemart_order_id) . ' ORDER BY id DESC LIMIT 1 ';
        $db->setQuery($q);
        if (!($pluginInfo = $db->loadObject())) {
            vmWarn('Attention, ' . $this->_tablename . ' has not any entry for the order ' . $db->getErrorMsg());

            return null;
        }
        $idName = $this->_psType . '_name';

        return $pluginInfo->$idName;
    }

    // funkcja wywołująca stricte zawartość komórki payment w szczegółach zamówienia (front - konto usera)


    function plgVmonShowOrderPrintPayment($order_number, $method_id)
    {
        return $this->onShowOrderPrint($order_number, $method_id);
    }

    // pobranie nazwy płatności z bazy 

    function plgVmDeclarePluginParamsPaymentVM3(&$data)
    {
        $virtuemart_paymentmethod_id = $_GET['cid'][0];
        $urlc = 'transferuj_wyn_url="' . JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&pm=' . $virtuemart_paymentmethod_id . '&status=confirm"|';
        $data->payment_params .= $urlc;

        return $this->declarePluginParams('payment', $data);
    }

    /**
     * This method is fired when showing when priting an Order
     * It displays the the payment method-specific data.
     *
     * @param integer $_virtuemart_order_id The order ID
     * @param integer $method_id method used for this order
     * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
     * @author Valerie Isaksen
     */
    // wymagane aby zapis XML'a do BD działał
    function plgVmSetOnTablePluginParamsPayment($name, $id, &$table)
    {
        return $this->setOnTablePluginParams($name, $id, $table);
    }

    // wymagane aby zapis XML'a do BD działał

    protected function checkConditions($cart, $method, $cart_prices)
    {
        return true;
    }

    // wymagane aby zapis XML'a do BD działał

    protected function getVmPluginCreateTableSQL()
    {
        return $this->createTableSQL('Payment Transferuj Table');
    }

}
